{******************************************************************************}
{                       CnPack For Delphi/C++Builder                           }
{                     йԼĿԴ                         }
{                   (C)Copyright 2001-2022 CnPack                        }
{                   ------------------------------------                       }
{                                                                              }
{            ǿԴ CnPack ķЭ        }
{        ĺ·һ                                                }
{                                                                              }
{            һĿϣãûκεû        }
{        ʺضĿĶĵϸ CnPack Э顣        }
{                                                                              }
{            ӦѾͿһյһ CnPack Эĸ        }
{        ûУɷǵվ                                            }
{                                                                              }
{            վַhttp://www.cnpack.org                                   }
{            ʼmaster@cnpack.org                                       }
{                                                                              }
{******************************************************************************}

unit CnNativeDecl;
{* |<PRE>
================================================================================
* ƣCnPack 
* Ԫƣ32 λ 64 λһЩͳһ
* ԪߣХ (liuxiao@cnpack.org)
*     עDelphi XE 2 ֧ 32  64 ų NativeInt  NativeUInt 
*           ǰ 32 λ 64 ̬仯Ӱ쵽 PointerReferenceȶ
*           ǵԣ̶ȵ 32 λ Cardinal/Integer Ⱥ Pointer Щ
*           ͨˣʹ 32 λҲֹ˱Ԫ˼ͣ
*           ͬʱڵͰ汾͸߰汾 Delphi ʹá
*            UInt64 İװע D567 ²ֱ֧UInt64 㣬Ҫ
*           ʵ֣Ŀǰʵ div  mod
*           ַ Integer(APtr)  64 λ MacOS ׳ֽضϣҪ NativeInt
* ƽ̨PWin2000 + Delphi 5.0
* ݲԣPWin9X/2000/XP + Delphi 5/6/7 XE 2
*   õԪеַϱػʽ
* ޸ļ¼2022.03.14 V2.0
*               Ӽʮת
*           2022.02.17 V1.9
*                FPC ı֧֣
*           2022.02.09 V1.8
*               ڵĴСжϺ
*           2021.09.05 V1.7
*                Int64/UInt64 㺯
*           2020.10.28 V1.6
*                UInt64 صж㺯
*           2020.09.06 V1.5
*                UInt64 ƽĺ
*           2020.07.01 V1.5
*               ж 32 λ 64 λ޷Ƿĺ
*           2020.06.20 V1.4
*                32 λ 64 λȡ͵ 1 λλõĺ
*           2020.01.01 V1.3
*                32 λ޷͵ mul 㣬ڲ֧ UInt64 ϵͳ Int64 Ա
*           2018.06.05 V1.2
*                64 λ͵ div/mod 㣬ڲ֧ UInt64 ϵͳ Int64  
*           2016.09.27 V1.1
*                64 λ͵һЩ
*           2011.07.06 V1.0
*               Ԫʵֹ
================================================================================
|</PRE>}

interface

{$I CnPack.inc}

uses
  Classes, SysUtils, SysConst, Math;

type
{$IFDEF SUPPORT_32_AND_64}
  TCnNativeInt     = NativeInt;
  TCnNativeUInt    = NativeUInt;
  TCnNativePointer = NativeUInt;
{$ELSE}
  TCnNativeInt     = Integer;
  TCnNativeUInt    = Cardinal;
  TCnNativePointer = Cardinal;
{$ENDIF}

{$IFDEF CPUX64}
  TCnUInt64        = NativeUInt;
  TCnInt64         = NativeInt;
{$ELSE}
  {$IFDEF SUPPORT_UINT64}
  TCnUInt64        = UInt64;
  {$ELSE}
  TCnUInt64 = packed record  // ֻĽṹ
    case Boolean of
      True:  (Value: Int64);
      False: (Low32, Hi32: Cardinal);
  end;
  {$ENDIF}
  TCnInt64         = Int64;
{$ENDIF}

// TUInt64  cnvcl в֧ UInt64  div mod 
{$IFDEF SUPPORT_UINT64}
  TUInt64          = UInt64;
  {$IFNDEF SUPPORT_PUINT64}
  PUInt64          = ^UInt64;
  {$ENDIF}
{$ELSE}
  TUInt64          = Int64;
  PUInt64          = ^TUInt64;
{$ENDIF}

{$IFNDEF SUPPORT_INT64ARRAY}
  // ϵͳûж Int64Array
  Int64Array  = array[0..$0FFFFFFE] of Int64;
  PInt64Array = ^Int64Array;
{$ENDIF}

  TUInt64Array = array of TUInt64; // ̬ƺ׺;̬гͻ

{$IFDEF POSIX64}
  TCnLongWord32 = Cardinal; // Linux64/MacOS64 (or POSIX64?) LongWord is 64 Bits
{$ELSE}
  TCnLongWord32 = LongWord;
{$ENDIF}
  PCnLongWord32 = ^TCnLongWord32;

const
  MAX_SQRT_INT64: Cardinal               = 3037000499;
  MAX_UINT16: Word                       = $FFFF;
  MAX_UINT32: Cardinal                   = $FFFFFFFF;
  MAX_TUINT64: TUInt64                   = $FFFFFFFFFFFFFFFF;
  MAX_SIGNED_INT64_IN_TUINT64: TUInt64   = $7FFFFFFFFFFFFFFF;

{*
   D567 Ȳ֧ UInt64 ıȻ Int64  UInt64 мӼ洢
  ˳޷ֱɣװ System е _lludiv  _llumod
  ʵ Int64 ʾ UInt64 ݵ div  mod ܡ
}
function UInt64Mod(A, B: TUInt64): TUInt64;
{*  UInt64 }

function UInt64Div(A, B: TUInt64): TUInt64;
{*  UInt64 }

function UInt64Mul(A, B: Cardinal): TUInt64;
{* ޷ 32 λˣڲ֧ UInt64 ƽ̨ϣ UInt64 ʽ Int64 
  ֱʹ Int64 п}

procedure UInt64AddUInt64(A, B: TUInt64; var ResLo, ResHi: TUInt64);
{* ޷ 64 λӣ ResLo  ResHi }

procedure UInt64MulUInt64(A, B: TUInt64; var ResLo, ResHi: TUInt64);
{* ޷ 64 λˣ ResLo  ResHi }

function UInt64ToHex(N: TUInt64): string;
{*  UInt64 תΪʮַ}

function UInt64ToStr(N: TUInt64): string;
{*  UInt64 תΪַ}

function StrToUInt64(const S: string): TUInt64;
{* ַתΪ UInt64}

function UInt64Compare(A, B: TUInt64): Integer;
{* Ƚ UInt64 ֱֵ > = <  10-1}

function UInt64Sqrt(N: TUInt64): TUInt64;
{*  UInt64 ƽ}

function UInt32IsNegative(N: Cardinal): Boolean;
{*  Cardinal  Integer ʱǷС 0}

function UInt64IsNegative(N: TUInt64): Boolean;
{*  UInt64  Int64 ʱǷС 0}

function GetUInt64BitSet(B: TUInt64; Index: Integer): Boolean;
{*  Int64 ĳһλǷ 1λ Index  0 ʼ}

function GetUInt64HighBits(B: TUInt64): Integer;
{*  Int64  1 ߶λǵڼλλ 0û 1 -1}

function GetUInt32HighBits(B: Cardinal): Integer;
{*  Cardinal  1 ߶λǵڼλλ 0û 1 -1}

function GetUInt64LowBits(B: TUInt64): Integer;
{*  Int64  1 Ͷλǵڼλλ 0ͬĩβ 0û 1 -1}

function GetUInt32LowBits(B: Cardinal): Integer;
{*  Cardinal  1 Ͷλǵڼλλ 0ͬĩβ 0û 1 -1}

function Int64Mod(M, N: Int64): Int64;
{* װ Int64 ModM ֵʱȡģģ N Ҫ}

function IsUInt32PowerOf2(N: Cardinal): Boolean;
{* жһ 32 λ޷Ƿ 2 }

function IsUInt64PowerOf2(N: TUInt64): Boolean;
{* жһ 64 λ޷Ƿ 2 }

function GetUInt32PowerOf2GreaterEqual(N: Cardinal): Cardinal;
{* õһָ 32 λ޷ȵ 2 ݣ򷵻 0}

function GetUInt64PowerOf2GreaterEqual(N: TUInt64): TUInt64;
{* õһָ 64 λ޷ȵ 2 ݣ򷵻 0}

function IsInt32AddOverflow(A, B: Integer): Boolean;
{* ж 32 λзǷ 32 λз}

function IsUInt32AddOverflow(A, B: Cardinal): Boolean;
{* ж 32 λ޷Ƿ 32 λ޷}

function IsInt64AddOverflow(A, B: Int64): Boolean;
{* ж 64 λзǷ 64 λз}

function IsUInt64AddOverflow(A, B: TUInt64): Boolean;
{* ж 64 λ޷Ƿ 64 λ޷}

function IsInt32MulOverflow(A, B: Integer): Boolean;
{* ж 32 λзǷ 32 λз}

function IsUInt32MulOverflow(A, B: Cardinal): Boolean;
{* ж 32 λ޷Ƿ 32 λ޷}

function IsUInt32MulOverflowInt64(A, B: Cardinal; out R: TUInt64): Boolean;
{* ж 32 λ޷Ƿ 64 λзδҲ False ʱR ֱӷؽ
  Ҳ TrueҪµ UInt64Mul ʵʩ}

function IsInt64MulOverflow(A, B: Int64): Boolean;
{* ж 64 λзǷ 64 λз}

function PointerToInteger(P: Pointer): Integer;
{* ָת֧ͣ 32/64 λ}

function IntegerToPointer(I: Integer): Pointer;
{* תָ֧ͣ 32/64 λ}

function Int64NonNegativeAddMod(A, B, N: Int64): Int64;
{*  Int64 Χĺ࣬Ҫ N  0}

function UInt64NonNegativeAddMod(A, B, N: TUInt64): TUInt64;
{*  UInt64 Χĺ࣬Ҫ N  0}

function Int64NonNegativeMulMod(A, B, N: Int64): Int64;
{* Int64 Χڵֱ࣬Ӽ㣬Ҫ N  0}

function UInt64NonNegativeMulMod(A, B, N: TUInt64): TUInt64;
{* UInt64 Χڵֱ࣬Ӽ㣬}

function Int64NonNegativeMod(N: Int64; P: Int64): Int64;
{* װ Int64 ǸຯҲΪʱӸ豣֤ P  0}

function Int64NonNegativPower(N: Int64; Exp: Integer): Int64;
{* Int64 ķǸָݣ}

function Int64NonNegativeRoot(N: Int64; Exp: Integer): Int64;
{*  Int64 ķǸη֣}

function UInt64NonNegativPower(N: TUInt64; Exp: Integer): TUInt64;
{* UInt64 ķǸָݣ}

function UInt64NonNegativeRoot(N: TUInt64; Exp: Integer): TUInt64;
{*  UInt64 ķǸη֣}

function CurrentByteOrderIsBigEndian: Boolean;
{* صǰڻǷǴˣҲǷеĸֽڴ洢ڽϵ͵ʼַ}

function CurrentByteOrderIsLittleEndian: Boolean;
{* صǰڻǷСˣҲǷеĸֽڴ洢ڽϸߵʼַ}

function Int64ToBigEndian(Value: Int64): Int64;
{* ȷ Int64 ֵΪˣС˻нת}

function Int32ToBigEndian(Value: Integer): Integer;
{* ȷ Int32 ֵΪˣС˻нת}

function Int16ToBigEndian(Value: SmallInt): SmallInt;
{* ȷ Int16 ֵΪˣС˻нת}

function Int64ToLittleEndian(Value: Int64): Int64;
{* ȷ Int64 ֵΪСˣ˻нת}

function Int32ToLittleEndian(Value: Integer): Integer;
{* ȷ Int32 ֵΪСˣ˻нת}

function Int16ToLittleEndian(Value: SmallInt): SmallInt;
{* ȷ Int16 ֵΪСˣ˻нת}

function DataToHex(InData: Pointer; ByteLength: Integer; UseUpperCase: Boolean = True): string;
{* ڴתΪʮַUseUpperCase ݵĴСд}

function HexToData(const Hex: string; OutData: Pointer): string;
{* ʮַתΪڴ飬ʮַΪתʧʱ׳쳣
  ע OutData Ӧָ㹻תݵ򣬳Ϊ Length(Hex) div 2}

function StringToHex(const Data: string; UseUpperCase: Boolean = True): string;
{* ַתΪʮַUseUpperCase ݵĴСд}

function HexToString(const Hex: string): string;
{* ʮַתΪַʮַΪתʧʱ׳쳣}

{$IFDEF TBYTES_DEFINED}

function BytesToHex(Data: TBytes; UseUpperCase: Boolean = True): string;
{* ֽתΪʮַUseUpperCase ݵĴСд}

function HexToBytes(const Hex: string): TBytes;
{* ʮַתΪֽ飬ַΪתʧʱ׳쳣}

{$ENDIF}

implementation

uses
  CnFloatConvert;

type
  PCnByte = ^Byte; //  Windows е PByte

function CurrentByteOrderIsBigEndian: Boolean;
type
  TByteOrder = packed record
    case Boolean of
      False: (C: array[0..1] of Byte);
      True: (W: Word);
  end;
var
  T: TByteOrder;
begin
  T.W := $00CC;
  Result := T.C[1] = $CC;
end;

function CurrentByteOrderIsLittleEndian: Boolean;
begin
  Result := not CurrentByteOrderIsBigEndian;
end;

function SwapInt64(Value: Int64): Int64;
var
  Lo, Hi: LongWord;
  Rec: Int64Rec;
begin
  Lo := Int64Rec(Value).Lo;
  Hi := Int64Rec(Value).Hi;
  Lo := ((Lo and $000000FF) shl 24) or ((Lo and $0000FF00) shl 8)
    or ((Lo and $00FF0000) shr 8) or ((Lo and $FF000000) shr 24);
  Hi := ((Hi and $000000FF) shl 24) or ((Hi and $0000FF00) shl 8)
    or ((Hi and $00FF0000) shr 8) or ((Hi and $FF000000) shr 24);
  Rec.Lo := Hi;
  Rec.Hi := Lo;
  Result := Int64(Rec);
end;

function Int64ToBigEndian(Value: Int64): Int64;
begin
  if CurrentByteOrderIsBigEndian then
    Result := Value
  else
    Result := SwapInt64(Value);
end;

function Int32ToBigEndian(Value: Integer): Integer;
begin
  if CurrentByteOrderIsBigEndian then
    Result := Value
  else
    Result := Integer((Value and $000000FF) shl 24) or Integer((Value and $0000FF00) shl 8)
      or Integer((Value and $00FF0000) shr 8) or Integer((Value and $FF000000) shr 24);
end;

function Int16ToBigEndian(Value: SmallInt): SmallInt;
begin
  if CurrentByteOrderIsBigEndian then
    Result := Value
  else
    Result := ((Value and $00FF) shl 8) or ((Value and $FF00) shr 8);
end;

function Int64ToLittleEndian(Value: Int64): Int64;
begin
  if CurrentByteOrderIsLittleEndian then
    Result := Value
  else
    Result := SwapInt64(Value);
end;

function Int32ToLittleEndian(Value: Integer): Integer;
begin
  if CurrentByteOrderIsLittleEndian then
    Result := Value
  else
    Result := Integer((Value and $000000FF) shl 24) or Integer((Value and $0000FF00) shl 8)
      or Integer((Value and $00FF0000) shr 8) or Integer((Value and $FF000000) shr 24);
end;

function Int16ToLittleEndian(Value: SmallInt): SmallInt;
begin
  if CurrentByteOrderIsLittleEndian then
    Result := Value
  else
    Result := ((Value and $00FF) shl 8) or ((Value and $FF00) shr 8);
end;

const
  HiDigits: array[0..15] of Char = ('0', '1', '2', '3', '4', '5', '6', '7',
                                  '8', '9', 'A', 'B', 'C', 'D', 'E', 'F');
const
  LoDigits: array[0..15] of Char = ('0', '1', '2', '3', '4', '5', '6', '7',
                                  '8', '9', 'a', 'b', 'c', 'd', 'e', 'f');

function HexToInt(const Hex: string): Integer;
var
  I, Res: Integer;
  C: Char;
begin
  Res := 0;
  for I := 0 to Length(Hex) - 1 do
  begin
    C := Hex[I + 1];
    if (C >= '0') and (C <= '9') then
      Res := Res * 16 + Ord(C) - Ord('0')
    else if (C >= 'A') and (C <= 'F') then
      Res := Res * 16 + Ord(C) - Ord('A') + 10
    else if (C >= 'a') and (C <= 'f') then
      Res := Res * 16 + Ord(C) - Ord('a') + 10
    else
      raise Exception.Create('Error: not a Hex String');
  end;
  Result := Res;
end;

function DataToHex(InData: Pointer; ByteLength: Integer; UseUpperCase: Boolean = True): string;
var
  I: Integer;
  B: Byte;
begin
  Result := '';
  if ByteLength <= 0 then
    Exit;

  SetLength(Result, ByteLength * 2);
  if UseUpperCase then
  begin
    for I := 0 to ByteLength - 1 do
    begin
      B := PCnByte(TCnNativeInt(InData) + I * SizeOf(Byte))^;
      Result[I * 2 + 1] := HiDigits[(B shr 4) and $0F];
      Result[I * 2 + 2] := HiDigits[B and $0F];
    end;
  end
  else
  begin
    for I := 0 to ByteLength - 1 do
    begin
      B := PCnByte(TCnNativeInt(InData) + I * SizeOf(Byte))^;
      Result[I * 2 + 1] := LoDigits[(B shr 4) and $0F];
      Result[I * 2 + 2] := LoDigits[B and $0F];
    end;
  end;
end;

function HexToData(const Hex: string; OutData: Pointer): string;
var
  I, L: Integer;
  S: string;
begin
  L := Length(Hex);
  if (L mod 2) <> 0 then
    raise Exception.Create('Error: not a Hex String');

  for I := 1 to L div 2 do
  begin
    S := Copy(Hex, I * 2 - 1, 2);
    PCnByte(TCnNativeInt(OutData) + I - 1)^ := Byte(HexToInt(S));
  end;
end;

function StringToHex(const Data: string; UseUpperCase: Boolean): string;
var
  I, L: Integer;
  B: Byte;
  Buffer: PChar;
begin
  Result := '';
  L := Length(Data);
  if L = 0 then
    Exit;

  SetLength(Result, L * 2);
  Buffer := @Data[1];

  if UseUpperCase then
  begin
    for I := 0 to L - 1 do
    begin
      B := PCnByte(TCnNativeInt(Buffer) + I * SizeOf(Char))^;
      Result[I * 2 + 1] := HiDigits[(B shr 4) and $0F];
      Result[I * 2 + 2] := HiDigits[B and $0F];
    end;
  end
  else
  begin
    for I := 0 to L - 1 do
    begin
      B := PCnByte(TCnNativeInt(Buffer) + I * SizeOf(Char))^;
      Result[I * 2 + 1] := LoDigits[(B shr 4) and $0F];
      Result[I * 2 + 2] := LoDigits[B and $0F];
    end;
  end;
end;

function HexToString(const Hex: string): string;
var
  I, L: Integer;
  S: string;
begin
  L := Length(Hex);
  if (L mod 2) <> 0 then
    raise Exception.Create('Error: not a Hex String');

  SetLength(Result, L div 2);
  for I := 1 to L div 2 do
  begin
    S := Copy(Hex, I * 2 - 1, 2);
    Result[I] := Chr(HexToInt(S));
  end;
end;

{$IFDEF TBYTES_DEFINED}

function BytesToHex(Data: TBytes; UseUpperCase: Boolean): string;
var
  I, L: Integer;
  B: Byte;
  Buffer: PAnsiChar;
begin
  Result := '';
  L := Length(Data);
  if L = 0 then
    Exit;

  SetLength(Result, L * 2);
  Buffer := @Data[0];

  if UseUpperCase then
  begin
    for I := 0 to L - 1 do
    begin
      B := PByte(TCnNativeInt(Buffer) + I)^;
      Result[I * 2 + 1] := HiDigits[(B shr 4) and $0F];
      Result[I * 2 + 2] := HiDigits[B and $0F];
    end;
  end
  else
  begin
    for I := 0 to L - 1 do
    begin
      B := PByte(TCnNativeInt(Buffer) + I)^;
      Result[I * 2 + 1] := LoDigits[(B shr 4) and $0F];
      Result[I * 2 + 2] := LoDigits[B and $0F];
    end;
  end;
end;

function HexToBytes(const Hex: string): TBytes;
var
  I, L: Integer;
  S: string;
begin
  L := Length(Hex);
  if (L mod 2) <> 0 then
    raise Exception.Create('Error: not a Hex String');

  SetLength(Result, L div 2);
  for I := 1 to L div 2 do
  begin
    S := Copy(Hex, I * 2 - 1, 2);
    Result[I - 1] := Byte(HexToInt(S));
  end;
end;

{$ENDIF}

{$IFDEF CPUX64}

function UInt64Mod(A, B: TUInt64): TUInt64;
begin
  Result := A mod B;
end;

function UInt64Div(A, B: TUInt64): TUInt64;
begin
  Result := A div B;
end;

{$ELSE}

{$IFDEF FPC}

function UInt64Mod(A, B: TUInt64): TUInt64;
begin
  Result := A mod B;
end;

function UInt64Div(A, B: TUInt64): TUInt64;
begin
  Result := A div B;
end;

{$ELSE}
{
  UInt64  A mod B

  õջ˳ A ĸλA ĵλB ĸλB ĵλ push ϲ뺯
  ESP ǷصַESP+4  B ĵλESP + 8  B ĸλESP + C  A ĵλESP + 10  A ĸλ
   push esp  ESP  4Ȼ mov ebp esp֮ EBP ѰַȫҪ 4

   System.@_llumod ҪڸսʱEAX <- A ĵλEDX <- A ĸλSystem Դע EAX/EDX дˣ
  [ESP + 8]Ҳ EBP + C<- B ĸλ[ESP + 4] Ҳ EBP + 8<- B ĵλ

   CALL ǰľƴ롣UInt64 Div Ҳ
}
function UInt64Mod(A, B: TUInt64): TUInt64;
asm
        // PUSH ESP  ESP  4Ҫ
        MOV     EAX, [EBP + $10]              // A Lo
        MOV     EDX, [EBP + $14]              // A Hi
        PUSH    DWORD PTR[EBP + $C]           // B Hi
        PUSH    DWORD PTR[EBP + $8]           // B Lo
        CALL    System.@_llumod;
end;

function UInt64Div(A, B: TUInt64): TUInt64;
asm
        // PUSH ESP  ESP  4Ҫ
        MOV     EAX, [EBP + $10]              // A Lo
        MOV     EDX, [EBP + $14]              // A Hi
        PUSH    DWORD PTR[EBP + $C]           // B Hi
        PUSH    DWORD PTR[EBP + $8]           // B Lo
        CALL    System.@_lludiv;
end;

{$ENDIF}

{$ENDIF}

{$IFDEF SUPPORT_UINT64}

function UInt64Mul(A, B: Cardinal): TUInt64;
begin
  Result := TUInt64(A) * B;
end;

{$ELSE}

{
  ޷ 32 λˣֱʹ Int64 ģ 64 λ޷

  üĴԼ A -> EAXB -> EDXʹöջ
   System.@_llmul ҪڸսʱEAX <- A ĵλEDX <- A ĸλ 0
  [ESP + 8]Ҳ EBP + C<- B ĸλ 0[ESP + 4] Ҳ EBP + 8<- B ĵλ
}
function UInt64Mul(A, B: Cardinal): TUInt64;
asm
        PUSH    0               // PUSH B λ 0
        PUSH    EDX             // PUSH B λ
                                // EAX A λѾ
        XOR     EDX, EDX        // EDX A λ 0
        CALL    System.@_llmul; //  EAX  32 λEDX  32 λ
end;

{$ENDIF}

// ޷ 64 λӣ ResLo  ResHi 
procedure UInt64AddUInt64(A, B: TUInt64; var ResLo, ResHi: TUInt64);
var
  X, Y, Z, T, R0L, R0H, R1L, R1H: Cardinal;
  R0, R1, R01, R12: TUInt64;
begin
  // ˼룺2^32 ϵ M (xM+y) + (zM+t) = (x+z) M + (y+t)
  // y+t  R0 ռ 01x+z  R1 ռ 12 R0, R1 ٲӳ R01, R12
  if IsUInt64AddOverflow(A, B) then
  begin
    X := Int64Rec(A).Hi;
    Y := Int64Rec(A).Lo;
    Z := Int64Rec(B).Hi;
    T := Int64Rec(B).Lo;

    R0 := TUInt64(Y) + TUInt64(T);
    R1 := TUInt64(X) + TUInt64(Z);

    R0L := Int64Rec(R0).Lo;
    R0H := Int64Rec(R0).Hi;
    R1L := Int64Rec(R1).Lo;
    R1H := Int64Rec(R1).Hi;

    R01 := TUInt64(R0H) + TUInt64(R1L);
    R12 := TUInt64(R1H) + TUInt64(Int64Rec(R01).Hi);

    Int64Rec(ResLo).Lo := R0L;
    Int64Rec(ResLo).Hi := Int64Rec(R01).Lo;
    Int64Rec(ResHi).Lo := Int64Rec(R12).Lo;
    Int64Rec(ResHi).Hi := Int64Rec(R12).Hi;
  end
  else
  begin
    ResLo := A + B;
    ResHi := 0;
  end;
end;

// ޷ 64 λˣ ResLo  ResHi 
procedure UInt64MulUInt64(A, B: TUInt64; var ResLo, ResHi: TUInt64);
var
  X, Y, Z, T: Cardinal;
  YT, XT, ZY, ZX: TUInt64;
  P, R1Lo, R1Hi, R2Lo, R2Hi: TUInt64;
begin
  // ˼룺2^32 ϵ M (xM+y)*(zM+t) = xzM^2 + (xt+yz)M + yt
  // ϵ UInt64xz ռ 234xt+yz ռ 123yt ռ01Ȼۼ
  X := Int64Rec(A).Hi;
  Y := Int64Rec(A).Lo;
  Z := Int64Rec(B).Hi;
  T := Int64Rec(B).Lo;

  YT := UInt64Mul(Y, T);
  XT := UInt64Mul(X, T);
  ZY := UInt64Mul(Y, Z);
  ZX := UInt64Mul(X, Z);

  Int64Rec(ResLo).Lo := Int64Rec(YT).Lo;

  P := Int64Rec(YT).Hi;
  UInt64AddUInt64(P, XT, R1Lo, R1Hi);
  UInt64AddUInt64(ZY, R1Lo, R2Lo, R2Hi);

  Int64Rec(ResLo).Hi := Int64Rec(R2Lo).Lo;

  P := TUInt64(Int64Rec(R2Lo).Hi) + TUInt64(Int64Rec(ZX).Lo);

  Int64Rec(ResHi).Lo := Int64Rec(P).Lo;
  Int64Rec(ResHi).Hi := Int64Rec(R1Hi).Lo + Int64Rec(R2Hi).Lo + Int64Rec(ZX).Hi + Int64Rec(P).Hi;
end;

function _ValUInt64(const S: string; var Code: Integer): TUInt64;
const
  FirstIndex = 1;
var
  I: Integer;
  Dig: Integer;
  Sign: Boolean;
  Empty: Boolean;
begin
  I := FirstIndex;
  Dig := 0;
  Result := 0;

  if S = '' then
  begin
    Code := 1;
    Exit;
  end;
  while S[I] = Char(' ') do
    Inc(I);
  Sign := False;
  if S[I] =  Char('-') then
  begin
    Sign := True;
    Inc(I);
  end
  else if S[I] =  Char('+') then
    Inc(I);
  Empty := True;

  if (S[I] =  Char('$')) or (UpCase(S[I]) =  Char('X'))
    or ((S[I] =  Char('0')) and (I < Length(S)) and (UpCase(S[I+1]) =  Char('X'))) then
  begin
    if S[I] =  Char('0') then
      Inc(I);
    Inc(I);
    while True do
    begin
      case   Char(S[I]) of
       Char('0').. Char('9'): Dig := Ord(S[I]) -  Ord('0');
       Char('A').. Char('F'): Dig := Ord(S[I]) - (Ord('A') - 10);
       Char('a').. Char('f'): Dig := Ord(S[I]) - (Ord('a') - 10);
      else
        Break;
      end;
      if Result > (MAX_TUINT64 shr 4) then
        Break;
      if Sign and (Dig <> 0) then
        Break;
      Result := Result shl 4 + Dig;
      Inc(I);
      Empty := False;
    end;
  end
  else
  begin
    while True do
    begin
      case Char(S[I]) of
        Char('0').. Char('9'): Dig := Ord(S[I]) - Ord('0');
      else
        Break;
      end;

      if Result > UInt64Div(MAX_TUINT64, 10) then
        Break;
      if Sign and (Dig <> 0) then
        Break;
      Result := Result * 10 + Dig;
      Inc(I);
      Empty := False;
    end;
  end;

  if (S[I] <> Char(#0)) or Empty then
    Code := I + 1 - FirstIndex
  else
    Code := 0;
end;

function UInt64ToHex(N: TUInt64): string;
const
  Digits: array[0..15] of Char = ('0', '1', '2', '3', '4', '5', '6', '7',
                                  '8', '9', 'A', 'B', 'C', 'D', 'E', 'F');

  function HC(B: Byte): string;
  begin
    Result := string(Digits[(B shr 4) and $0F] + Digits[B and $0F]);
  end;

begin
  Result :=
      HC(Byte((N and $FF00000000000000) shr 56))
    + HC(Byte((N and $00FF000000000000) shr 48))
    + HC(Byte((N and $0000FF0000000000) shr 40))
    + HC(Byte((N and $000000FF00000000) shr 32))
    + HC(Byte((N and $00000000FF000000) shr 24))
    + HC(Byte((N and $0000000000FF0000) shr 16))
    + HC(Byte((N and $000000000000FF00) shr 8))
    + HC(Byte((N and $00000000000000FF)));
end;

function UInt64ToStr(N: TUInt64): string;
begin
  Result := Format('%u', [N]);
end;

function StrToUInt64(const S: string): TUInt64;
{$IFNDEF DELPHIXE6_UP}
var
  E: Integer;
{$ENDIF}
begin
{$IFDEF DELPHIXE6_UP}
  Result := SysUtils.StrToUInt64(S);  // StrToUInt64 only exists under XE6 or above
{$ELSE}
  Result := _ValUInt64(S,  E);
  if E <> 0 then raise EConvertError.CreateResFmt(@SInvalidInteger, [S]);
{$ENDIF}
end;

function UInt64Compare(A, B: TUInt64): Integer;
{$IFNDEF SUPPORT_UINT64}
var
  HiA, HiB, LoA, LoB: LongWord;
{$ENDIF}
begin
{$IFDEF SUPPORT_UINT64}
  if A > B then
    Result := 1
  else if A < B then
    Result := -1
  else
    Result := 0;
{$ELSE}
  HiA := (A and $FFFFFFFF00000000) shr 32;
  HiB := (B and $FFFFFFFF00000000) shr 32;
  if HiA > HiB then
    Result := 1
  else if HiA < HiB then
    Result := -1
  else
  begin
    LoA := LongWord(A and $00000000FFFFFFFF);
    LoB := LongWord(B and $00000000FFFFFFFF);
    if LoA > LoB then
      Result := 1
    else if LoA < LoB then
      Result := -1
    else
      Result := 0;
  end;
{$ENDIF}
end;

function UInt64Sqrt(N: TUInt64): TUInt64;
var
  Rem, Root: TUInt64;
  I: Integer;
begin
  Result := 0;
  if N = 0 then
    Exit;

  if UInt64Compare(N, 4) < 0 then
  begin
    Result := 1;
    Exit;
  end;

  Rem := 0;
  Root := 0;

  for I := 0 to 31 do
  begin
    Root := Root shl 1;
    Inc(Root);

    Rem := Rem shl 2;
    Rem := Rem or (N shr 62);
    N := N shl 2;

    if UInt64Compare(Root, Rem) <= 0 then
    begin
      Rem := Rem - Root;
      Inc(Root);
    end
    else
      Dec(Root);
  end;
  Result := Root shr 1;
end;

function UInt32IsNegative(N: Cardinal): Boolean;
begin
  Result := (N and (1 shl 31)) <> 0;
end;

function UInt64IsNegative(N: TUInt64): Boolean;
begin
{$IFDEF SUPPORT_UINT64}
  Result := (N and (UInt64(1) shl 63)) <> 0;
{$ELSE}
  Result := N < 0;
{$ENDIF}
end;

//  UInt64 ĵڼλǷ 10 ʼ
function GetUInt64BitSet(B: TUInt64; Index: Integer): Boolean;
begin
  B := B and (TUInt64(1) shl Index);
  Result := B <> 0;
end;

//  Int64  1 ߶λǵڼλλ 0û 1 -1
function GetUInt64HighBits(B: TUInt64): Integer;
begin
  if B = 0 then
  begin
    Result := -1;
    Exit;
  end;

  Result := 1;
  if B shr 32 = 0 then
  begin
   Inc(Result, 32);
   B := B shl 32;
  end;
  if B shr 48 = 0 then
  begin
   Inc(Result, 16);
   B := B shl 16;
  end;
  if B shr 56 = 0 then
  begin
    Inc(Result, 8);
    B := B shl 8;
  end;
  if B shr 60 = 0 then
  begin
    Inc(Result, 4);
    B := B shl 4;
  end;
  if B shr 62 = 0 then
  begin
    Inc(Result, 2);
    B := B shl 2;
  end;
  Result := Result - Integer(B shr 63); // õǰ 0 
  Result := 63 - Result;
end;

//  Cardinal  1 ߶λǵڼλλ 0û 1 -1
function GetUInt32HighBits(B: Cardinal): Integer;
begin
  if B = 0 then
  begin
    Result := -1;
    Exit;
  end;

  Result := 1;
  if B shr 16 = 0 then
  begin
   Inc(Result, 16);
   B := B shl 16;
  end;
  if B shr 24 = 0 then
  begin
    Inc(Result, 8);
    B := B shl 8;
  end;
  if B shr 28 = 0 then
  begin
    Inc(Result, 4);
    B := B shl 4;
  end;
  if B shr 30 = 0 then
  begin
    Inc(Result, 2);
    B := B shl 2;
  end;
  Result := Result - Integer(B shr 31); // õǰ 0 
  Result := 31 - Result;
end;

//  Int64  1 Ͷλǵڼλλ 0û 1 -1
function GetUInt64LowBits(B: TUInt64): Integer;
var
  Y: TUInt64;
  N: Integer;
begin
  Result := -1;
  if B = 0 then
    Exit;

  N := 63;
  Y := B shl 32;
  if Y <> 0 then
  begin
    Dec(N, 32);
    B := Y;
  end;
  Y := B shl 16;
  if Y <> 0 then
  begin
    Dec(N, 16);
    B := Y;
  end;
  Y := B shl 8;
  if Y <> 0 then
  begin
    Dec(N, 8);
    B := Y;
  end;
  Y := B shl 4;
  if Y <> 0 then
  begin
    Dec(N, 4);
    B := Y;
  end;
  Y := B shl 2;
  if Y <> 0 then
  begin
    Dec(N, 2);
    B := Y;
  end;
  B := B shl 1;
  Result := N - Integer(B shr 63);
end;

//  Cardinal  1 Ͷλǵڼλλ 0û 1 -1
function GetUInt32LowBits(B: Cardinal): Integer;
var
  Y, N: Integer;
begin
  Result := -1;
  if B = 0 then
    Exit;

  N := 31;
  Y := B shl 16;
  if Y <> 0 then
  begin
    Dec(N, 16);
    B := Y;
  end;
  Y := B shl 8;
  if Y <> 0 then
  begin
    Dec(N, 8);
    B := Y;
  end;
  Y := B shl 4;
  if Y <> 0 then
  begin
    Dec(N, 4);
    B := Y;
  end;
  Y := B shl 2;
  if Y <> 0 then
  begin
    Dec(N, 2);
    B := Y;
  end;
  B := B shl 1;
  Result := N - Integer(B shr 31);
end;

// װ Int64 Modֵʱȡģģ
function Int64Mod(M, N: Int64): Int64;
begin
  if M > 0 then
    Result := M mod N
  else
    Result := N - ((-M) mod N);
end;

// жһ 32 λ޷Ƿ 2 
function IsUInt32PowerOf2(N: Cardinal): Boolean;
begin
  Result := (N and (N - 1)) = 0;
end;

// жһ 64 λ޷Ƿ 2 
function IsUInt64PowerOf2(N: TUInt64): Boolean;
begin
  Result := (N and (N - 1)) = 0;
end;

// õһָ 32 λ޷ȵ 2 ݣ򷵻 0
function GetUInt32PowerOf2GreaterEqual(N: Cardinal): Cardinal;
begin
  Result := N - 1;
  Result := Result or (Result shr 1);
  Result := Result or (Result shr 2);
  Result := Result or (Result shr 4);
  Result := Result or (Result shr 8);
  Result := Result or (Result shr 16);
  Inc(Result);
end;

// õһָ 64 λ޷ 2 ݣ򷵻 0
function GetUInt64PowerOf2GreaterEqual(N: TUInt64): TUInt64;
begin
  Result := N - 1;
  Result := Result or (Result shr 1);
  Result := Result or (Result shr 2);
  Result := Result or (Result shr 4);
  Result := Result or (Result shr 8);
  Result := Result or (Result shr 16);
  Result := Result or (Result shr 32);
  Inc(Result);
end;

// ж 32 λзǷ 32 λз
function IsInt32AddOverflow(A, B: Integer): Boolean;
var
  C: Integer;
begin
  C := A + B;
  Result := ((A > 0) and (B > 0) and (C < 0)) or   // ͬҽ˵
    ((A < 0) and (B < 0) and (C > 0));
end;

// ж 32 λ޷Ƿ 32 λ޷
function IsUInt32AddOverflow(A, B: Cardinal): Boolean;
begin
  Result := (A + B) < A; // ޷ӣֻҪСһ˵
end;

// ж 64 λзǷ 64 λз
function IsInt64AddOverflow(A, B: Int64): Boolean;
var
  C: Int64;
begin
  C := A + B;
  Result := ((A > 0) and (B > 0) and (C < 0)) or   // ͬҽ˵
    ((A < 0) and (B < 0) and (C > 0));
end;

// ж 64 λ޷Ƿ 64 λ޷
function IsUInt64AddOverflow(A, B: TUInt64): Boolean;
begin
  Result := UInt64Compare(A + B, A) < 0; // ޷ӣֻҪСһ˵
end;

// ж 32 λзǷ 32 λз
function IsInt32MulOverflow(A, B: Integer): Boolean;
var
  T: Integer;
begin
  T := A * B;
  Result := (B <> 0) and ((T div B) <> A);
end;

// ж 32 λ޷Ƿ 32 λ޷
function IsUInt32MulOverflow(A, B: Cardinal): Boolean;
var
  T: TUInt64;
begin
  T := TUInt64(A) * TUInt64(B);
  Result := (T = Cardinal(T));
end;

// ж 32 λ޷Ƿ 64 λзδҲ False ʱR ֱӷؽ
function IsUInt32MulOverflowInt64(A, B: Cardinal; out R: TUInt64): Boolean;
var
  T: Int64;
begin
  T := Int64(A) * Int64(B);
  Result := T < 0; //  Int64 ֵ˵
  if not Result then
    R := TUInt64(T);
end;

// ж 64 λзǷ 64 λз
function IsInt64MulOverflow(A, B: Int64): Boolean;
var
  T: Int64;
begin
  T := A * B;
  Result := (B <> 0) and ((T div B) <> A);
end;

// ָת֧ͣ 32/64 λ
function PointerToInteger(P: Pointer): Integer;
begin
{$IFDEF CPUX64}
  // ôд Pointer ĵ 32 λ Integer
  Result := Integer(P);
{$ELSE}
  Result := Integer(P);
{$ENDIF}
end;

// תָ֧ͣ 32/64 λ
function IntegerToPointer(I: Integer): Pointer;
begin
{$IFDEF CPUX64}
  // ôд Pointer ĵ 32 λ Integer
  Result := Pointer(I);
{$ELSE}
  Result := Pointer(I);
{$ENDIF}
end;

//  Int64 Χĺ࣬Ҫ N  0
function Int64NonNegativeAddMod(A, B, N: Int64): Int64;
begin
  if IsInt64AddOverflow(A, B) then //  Int64
  begin
    if A > 0 then
    begin
      // A  B  0 UInt64 ȡģδ UInt64 ޣע N δ Int64 ȡģС Int64 ޣɸֵ
      Result := UInt64NonNegativeAddMod(A, B, N);
    end
    else
    begin
      // A  B С 0ȡ UInt64 ȡģĺδ UInt64 ޣģٱһ
      Result := N - UInt64NonNegativeAddMod(-A, -B, N);
    end;
  end
  else // ֱӼ
    Result := Int64NonNegativeMod(A + B, N);
end;

//  UInt64 Χĺ࣬Ҫ N  0
function UInt64NonNegativeAddMod(A, B, N: TUInt64): TUInt64;
var
  C, D: TUInt64;
begin
  if IsUInt64AddOverflow(A, B) then // 
  begin
    C := UInt64Mod(A, N);  // ͸ģ
    D := UInt64Mod(B, N);
    if IsUInt64AddOverflow(C, D) then
    begin
      // ˵ģ󣬸ģûá
      // һڵ 2^63N  2^63 + 1
      //  =  + 2^64
      //  mod N =  mod N + (2^64 - 1) mod N) + 1
      //  N  2^63 + 1 2^64 - 2ǰӲֱӺһģ
      Result := UInt64Mod(UInt64Mod(A + B, N) + UInt64Mod(MAX_TUINT64, N) + 1, N);
    end
    else
      Result := UInt64Mod(C + D, N);
  end
  else
  begin
    Result := UInt64Mod(A + B, N);
  end;
end;

function Int64NonNegativeMulMod(A, B, N: Int64): Int64;
var
  Neg: Boolean;
begin
  if N <= 0 then
    raise EDivByZero.Create(SDivByZero);

  // ΧСֱ
  if not IsInt64MulOverflow(A, B) then
  begin
    Result := A * B mod N;
    if Result < 0 then
      Result := Result + N;
    Exit;
  end;

  // ŵ
  Result := 0;
  if (A = 0) or (B = 0) then
    Exit;

  Neg := False;
  if (A < 0) and (B > 0) then
  begin
    A := -A;
    Neg := True;
  end
  else if (A > 0) and (B < 0) then
  begin
    B := -B;
    Neg := True;
  end
  else if (A < 0) and (B < 0) then
  begin
    A := -A;
    B := -B;
  end;

  // λѭ
  while B <> 0 do
  begin
    if (B and 1) <> 0 then
      Result := ((Result mod N) + (A mod N)) mod N;

    A := A shl 1;
    if A >= N then
      A := A mod N;

    B := B shr 1;
  end;

  if Neg then
    Result := N - Result;
end;

function UInt64NonNegativeMulMod(A, B, N: TUInt64): TUInt64;
begin
  Result := 0;
  if (UInt64Compare(A, MAX_UINT32) <= 0) and (UInt64Compare(B, MAX_UINT32) <= 0) then
  begin
    Result := UInt64Mod(A * B, N); // 㹻СĻֱӳ˺ģ
  end
  else
  begin
    while B <> 0 do
    begin
      if (B and 1) <> 0 then
        Result := UInt64NonNegativeAddMod(Result, A, N);

      A := UInt64NonNegativeAddMod(A, A, N);
      // ôͳ㷨 A := A shl 1 N  mod NΪ

      B := B shr 1;
    end;
  end;
end;

// װķǸຯҲΪʱӸ豣֤ P  0
function Int64NonNegativeMod(N: Int64; P: Int64): Int64;
begin
  if P <= 0 then
    raise EDivByZero.Create(SDivByZero);

  Result := N mod P;
  if Result < 0 then
    Inc(Result, P);
end;

// Int64 ķǸָ
function Int64NonNegativPower(N: Int64; Exp: Integer): Int64;
var
  T: Int64;
begin
  if Exp < 0 then
    raise ERangeError.Create(SRangeError)
  else if Exp = 0 then
  begin
    if N <> 0 then
      Result := 1
    else
      raise EDivByZero.Create(SDivByZero);
  end
  else if Exp = 1 then
    Result := N
  else
  begin
    Result := 1;
    T := N;

    while Exp > 0 do
    begin
      if (Exp and 1) <> 0 then
        Result := Result * T;

      Exp := Exp shr 1;
      T := T * T;
    end;
  end;
end;

function Int64NonNegativeRoot(N: Int64; Exp: Integer): Int64;
var
  I: Integer;
  X: Int64;
  X0, X1: Extended;
begin
  if (Exp < 0) or (N < 0) then
    raise ERangeError.Create(SRangeError)
  else if Exp = 0 then
    raise EDivByZero.Create(SDivByZero)
  else if (N = 0) or (N = 1) then
    Result := N
  else if Exp = 2 then
    Result := UInt64Sqrt(N)
  else
  begin
    // ţٵ
    I := GetUInt64HighBits(N) + 1; // õԼ Log2 N ֵ
    I := (I div Exp) + 1;
    X := 1 shl I;                  // õһϴ X0 ֵΪʼֵ

    X0 := X;
    X1 := X0 - (Power(X0, Exp) - N) / (Exp * Power(X0, Exp - 1));

    while True do
    begin
      if (Trunc(X0) = Trunc(X1)) and (Abs(X0 - X1) < 0.001) then
      begin
        Result := Trunc(X1); // Trunc ֻ֧ Int64˻
        Exit;
      end;

      X0 := X1;
      X1 := X0 - (Power(X0, Exp) - N) / (Exp * Power(X0, Exp - 1));
    end;
  end;
end;

function UInt64NonNegativPower(N: TUInt64; Exp: Integer): TUInt64;
var
  T, RL, RH: TUInt64;
begin
  if Exp < 0 then
    raise ERangeError.Create(SRangeError)
  else if Exp = 0 then
  begin
    if N <> 0 then
      Result := 1
    else
      raise EDivByZero.Create(SDivByZero);
  end
  else if Exp = 1 then
    Result := N
  else
  begin
    Result := 1;
    T := N;

    while Exp > 0 do
    begin
      if (Exp and 1) <> 0 then
      begin
        UInt64MulUInt64(Result, T, RL, RH);
        Result := RL;
      end;

      Exp := Exp shr 1;
      UInt64MulUInt64(T, T, RL, RH);
      T := RL;
    end;
  end;
end;

function UInt64NonNegativeRoot(N: TUInt64; Exp: Integer): TUInt64;
var
  I: Integer;
  X: TUInt64;
  XN, X0, X1: Extended;
begin
  if Exp < 0 then
    raise ERangeError.Create(SRangeError)
  else if Exp = 0 then
    raise EDivByZero.Create(SDivByZero)
  else if (N = 0) or (N = 1) then
    Result := N
  else if Exp = 2 then
    Result := UInt64Sqrt(N)
  else
  begin
    // ţٵ
    I := GetUInt64HighBits(N) + 1; // õԼ Log2 N ֵ
    I := (I div Exp) + 1;
    X := 1 shl I;                  // õһϴ X0 ֵΪʼֵ

    X0 := UInt64ToExtended(X);
    XN := UInt64ToExtended(N);
    X1 := X0 - (Power(X0, Exp) - XN) / (Exp * Power(X0, Exp - 1));

    while True do
    begin
      if (ExtendedToUInt64(X0) = ExtendedToUInt64(X1)) and (Abs(X0 - X1) < 0.001) then
      begin
        Result := ExtendedToUInt64(X1);
        Exit;
      end;

      X0 := X1;
      X1 := X0 - (Power(X0, Exp) - XN) / (Exp * Power(X0, Exp - 1));
    end;
  end;
end;

end.
